Description

In the current implementation of the Redmine Journal model, the updated_by_id field stores the id of the user who last edited the

notes. However, if the user associated with this id is deleted, the id remains pointing to the deleted user.

To ensure consistent behavior across Redmine, the updated_by_id should be set to User.anonymous.id when the associated user is

deleted.

Steps to Reproduce:

1. Create an issue and add a notes to it.

2. Edit the notes as a specific user, which will set the updated_by_id.

3. Delete the user who last edited the notes.

4. Query the Journal model and check the updated_by_id field. The expected value is User.anonymous.id, however, it retains the

deleted user's id.

Related issues:

Related to Redmine - Feature #31505: Mark edited journal notes as "Edited" Closed

Associated revisions

Revision 23169 - 2024-10-29 02:02 - Go MAEDA

Fix: `updated_by_id` in Journal points to a deleted user instead of an anonymous user (#41572).

Patch by Go MAEDA (user:maeda).

Revision 23170 - 2024-10-29 02:11 - Go MAEDA

Add a migration to update existing journals where `updated_by_id` points to a deleted user (#41572).

History

#1 - 2024-10-24 10:42 - Go MAEDA

- Related to Feature #31505: Mark edited journal notes as "Edited" added

#2 - 2024-10-24 10:52 - Go MAEDA

- File clipboard-202410241750-dvuxc.png added

- File clipboard-202410241751-epej4.png added

- File 41572.patch added

Here is a patch that fixes this issue.

Before:

 clipboard-202410241750-dvuxc.png 

After:
clipboard-202410241751-epej4.png 

#3 - 2024-10-24 21:43 - Holger Just

We probably need a migration in addition to that to clear the existing fields where a user was previously deleted, e.g. by updating the @updated_by

field of all journals where the referenced user does not exist (anymore).
#4 - 2024-10-26 06:44 - Go MAEDA

- File 41572-v2.patch added

Holger Just wrote in #note-3:

We probably need a migration in addition to that to clear the existing fields where a user was previously deleted, e.g. by updating the

@updated_by field of all journals where the referenced user does not exist (anymore).

 I have updated the patch. The new patch includes a migration that sets the anonymous users' id to the updated_by_id field when it points to a

nonexistent user.

#5 - 2024-10-26 07:23 - Go MAEDA

- File deleted (41572-v2.patch)

#6 - 2024-10-26 07:24 - Go MAEDA

- File 41572-v2.patch added

#7 - 2024-10-26 07:55 - Go MAEDA

- File 41572-v2.patch added

- File deleted (41572-v2.patch)

#8 - 2024-10-28 16:12 - Holger Just

Thanks, that should work. I like your solution for handling a new installation!

#9 - 2024-10-29 02:03 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Target version set to 6.0.0

- Resolution set to Fixed

I have committed the fix in r23169.

Holger Just, thank you for reviewing the patch.
